%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Program for paper "Demographics and the Behavior of Interest Rate" (2010) 
% by Carlo A. Favero, Arie E. Gozlukluy and Haoxi Yang
% Simulation (Comparison between macro factors and MY based on NA term structure model)
% Haoxi Yang Nov. 25,2010
%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% This code just use the whole sample estimators to simulate yield curve
% for different maturities. Here we just simulate the case with constant
% risk premium.(lamda1=zeros(5,5))
%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear all;
clc; 
addpath('.\data;','.\Library;','.\Results;')
%% simulation with 1964q1 as initial point 
load estimation_demog_trp0_wholesample.mat;
[k t]=size(yy);
% the file we read from temp folder is the estimation result for whole
% sample (1969q1-2007q4) the result file kept in estimation results\wiht
% MY\whole sample
fname = [cd, '\Results\Estimation\CS3_tays1_ma2',num2str(mac),'_f_trp',num2str(trp),'_rest',num2str(rest)];
load(fname);
theta = thetall(:,end);
phi = reshape(theta(1:K^2),K,K); 
del2= theta(end);
Xs = zeros(K,t);
Xs(1:K-K2,1)=Xo(:,1);
Xs(K2:end,1)=Xu(:,1);
[k1 t1]=size(Xs);

for i=1:k1
    mXs(1,i) = mean(Xstate(i+1,:));
end
mu = (eye(K)-phi)*mXs';
for i=2:t
    Xs(:,i)=mu+phi*Xs(:,i-1);
end
my_1= -my(1 + nRoll:mRoll+nRoll, 1);
my_2= my_1-mean(my_1);
ys = zeros(k,t);
% del2 = 0.028
for j=1:t
    ys(:,j) = 400*(AA1 +  BB1*Xs(:,j) + del2*ones(6,1)*my_2(j)); %+100*del2*(-mean(my_1))*ones(6,1);
end
ys_1qh_my=ys';
fname = [cd,'\Results\simulation\ys_1qh_my'];
save(fname, 'ys_1qh_my');

% load estimation_trp1_wholesample.mat;
fname = [cd, '\Results\Estimation\CS3_ll_ma2',num2str(mac),'_f_trp',num2str(trp)];
load(fname);
theta = thetall(:,end);
phi = reshape(theta(1:K^2),K,K); 
Xs = zeros(K,t);
Xs(1:K-K2,1)=Xo(:,1);
Xs(K2:end,1)=Xu(:,1);
[k1 t1]=size(Xs);

for i=1:k1
    mXs(1,i) = mean(Xstate(i+1,:));
end
mu = (eye(K)-phi)*mXs';
for i=2:t
    Xs(:,i)=mu+phi*Xs(:,i-1);
end

ys = zeros(k,t);
for j=1:t
    ys(:,j) = 400*(AA1 + BB1*Xs(:,j));
end 
ys_1qh=ys';
fname = [cd,'\Results\simulation\ys_1qh'];
save(fname, 'ys_1qh');

%% Graph comparison
% Define path and load data
%%% 1 quarter ahead simulation plotting
fname = [cd, '\Results\simulation\ys_1qh'];  
load(fname);
yield_f1 = ys_1qh;
fname = [cd, '\Results\simulation\ys_1qh_my'];  
load(fname);
yield_f1_m = ys_1qh_my;
[n,m]=size(yield_f1);
yields = yield(end-n+1:end,:);
Time_data = 1964+1/4 : 1/4 : 2013+4/4;    
t=Time_data';
figure
   subplot(3,2,1);plot(t,yields(:,1)','LineWidth',2.5,'Color','black');title('3 Month Bond Yield');hold on
                  plot(t,yield_f1(:,1)','LineWidth',3,'Color',[0.501960813999176 0.501960813999176 0.501960813999176],'LineStyle',':');
                  plot(t,yield_f1_m(:,1)','LineWidth',3,'Color',[0.313725501298904 0.313725501298904 0.313725501298904],'LineStyle','--');
                  area([2008.75 2014], [16 16]);hold on
                  plot(t,yields(:,1)','LineWidth',2.5,'Color','black');title('3 Month Bond Yield');hold on
                  plot(t,yield_f1(:,1)','LineWidth',3,'Color',[0.501960813999176 0.501960813999176 0.501960813999176],'LineStyle',':');
                  plot(t,yield_f1_m(:,1)','LineWidth',3,'Color',[0.313725501298904 0.313725501298904 0.313725501298904],'LineStyle','--');
                  legend('Data','Restricted Model','Unrestricted Model')
                  hold off;
                  xlim([1964 2014.1]); ylim([-0.05 16.15]);
%                   grid on
   subplot(3,2,2);area([2008.75 2014], [16 16]);hold on
                  plot(t,yields(:,2)','LineWidth',2.5,'Color','black');title('1 Year Bond Yield');hold on
                  plot(t,yield_f1(:,2)','LineWidth',3,'Color',[0.501960813999176 0.501960813999176 0.501960813999176],'LineStyle',':');
                  plot(t,yield_f1_m(:,2)','LineWidth',3,'Color',[0.313725501298904 0.313725501298904 0.313725501298904],'LineStyle','--');
                  hold off; xlim([1964 2014.1]); ylim([-0.05 16.15]);
%                   grid on
   subplot(3,2,3);area([2008.75 2014], [16 16]);hold on
                  plot(t,yields(:,3)','LineWidth',2.5,'Color','black');title('2 Years Bond Yield');hold on
                  plot(t,yield_f1(:,3)','LineWidth',3,'Color',[0.501960813999176 0.501960813999176 0.501960813999176],'LineStyle',':');
                  plot(t,yield_f1_m(:,3)','LineWidth',3,'Color',[0.313725501298904 0.313725501298904 0.313725501298904],'LineStyle','--');
                  hold off; xlim([1964 2014.1]); ylim([-0.05 16.15]);
%                   grid on
   subplot(3,2,4);area([2008.75 2014], [16 16]);hold on
                  plot(t,yields(:,4)','LineWidth',2.5,'Color','black');title('3 Years Bond Yield');hold on
                  plot(t,yield_f1(:,4)','LineWidth',3,'Color',[0.501960813999176 0.501960813999176 0.501960813999176],'LineStyle',':');
                  plot(t,yield_f1_m(:,4)','LineWidth',3,'Color',[0.313725501298904 0.313725501298904 0.313725501298904],'LineStyle','--');
                  hold off; xlim([1964 2014.1]); ylim([-0.05 16.15]);
%                   grid on
   subplot(3,2,5);area([2008.75 2014], [16 16]);hold on
                  plot(t,yields(:,5)','LineWidth',2.5,'Color','black');title('4 Years Bond Yield');hold on
                  plot(t,yield_f1(:,5)','LineWidth',3,'Color',[0.501960813999176 0.501960813999176 0.501960813999176],'LineStyle',':');
                  plot(t,yield_f1_m(:,5)','LineWidth',3,'Color',[0.313725501298904 0.313725501298904 0.313725501298904],'LineStyle','--');
                  hold off; xlim([1964 2014.1]); ylim([-0.05 16.15]);
%                   grid on
   subplot(3,2,6);area([2008.75 2014], [16 16]);hold on
                  plot(t,yields(:,6)','LineWidth',2.5,'Color','black');title('5 Years Bond Yield');hold on
                  plot(t,yield_f1(:,6)','LineWidth',3,'Color',[0.501960813999176 0.501960813999176 0.501960813999176],'LineStyle',':');
                  plot(t,yield_f1_m(:,6)','LineWidth',3,'Color',[0.313725501298904 0.313725501298904 0.313725501298904],'LineStyle','--');
                  hold off; xlim([1964 2014.1]); ylim([-0.05 16.15]);
%                   grid on

% 
% %% 3 years ahead simulation
% h = 12;
% Xh = [Xo' Xu']';
% Xs = zeros(K,t);
% Xs(:,h) = Xh(:,h);
% [k1 t1]=size(Xs);
% 
% for i=1:k1
%     mXs(1,i) = mean(Xstate(i+1,:));
% end
% mu = (eye(K)-phi)*mXs';
% mu_h = zeros(K,1);
% for h=1:12
%     mu_h = mu_h+ phi^(h-1)*mu;
%     phi_h = phi^h;
% end
% for i=13:t
%     Xs(:,i)=mu_h+phi_h*[Xh(1:2,i-12)' Xs(3:5,i-12)']';
% end
% 
% my_1= -my(1 + nRoll:mRoll+nRoll, 1);
% my_2= my_1-mean(my_1);
% ys = zeros(k,t);
% for j=13:t
%     ys(:,j) =(AA1 +  BB1*Xs(:,j) + del2*ones(6,1)*my_2(j))*400; %+ 100*del2*(-mean(my_1))*ones(6,1);
% end 
% ys_3yh_my=ys';
% fname = [cd,'\Results\simulation\ys_3yh_my'];
% save(fname, 'ys_3yh_my');
% 
% fname = [cd, '\Results\temp\CS3_tays1_ma2',num2str(mac),'_f_trp',num2str(trp),'_rest',num2str(rest)];
% load(fname);
% theta = thetall(:,end);
% phi = reshape(theta(1:K^2),K,K); 
% h = 12; %the number of periods ahead
% Xh = [Xo' Xu']';
% Xs = zeros(K,t);
% Xs(:,h) = Xh(:,h);
% [k1 t1]=size(Xs);
% 
% for i=1:k1
%     mXs(1,i) = mean(Xstate(i+1,:));
% end
% mu = (eye(K)-phi)*mXs';
% mu_h = zeros(K,1);
% for h=1:12
%     mu_h = mu_h+ phi^(h-1)*mu;
%     phi_h = phi^h;
% end
% for i=13:t
%     Xs(:,i)=mu_h+phi_h*[Xh(1:2,i-12)' Xs(3:5,i-12)']';
% end
% 
% ys = zeros(k,t);
% for j=13:t
%     ys(:,j) = (AA1 +  BB1*Xs(:,j))*400 ;
% end 
% ys_3yh=ys';
% fname = [cd,'\Results\simulation\ys_3yh'];
% save(fname, 'ys_3yh');                  
% % simulation plotting
% fname = [cd, '\Results\simulation\ys_3yh'];  
% load(fname);
% yield_f3 = ys_3yh(h+1:end,:);
% fname = [cd, '\Results\simulation\ys_3yh_my'];  
% load(fname);
% yield_f3_m = ys_3yh_my(h+1:end,:);
% [n,m]=size(yield_f3);
% yields = yield(end-n+1:end,:);
% Time_data = 1972+1/4 : 1/4 : 2007+4/4;    
% t=Time_data';
% figure
%    subplot(3,2,1);plot(t,yields(:,1)','LineWidth',1.6,'Color','red');title('3 Month Bond Yield');hold on
%                   plot(t,yield_f3(:,1)','LineWidth',2,'Color','green','LineStyle',':');
%                   plot(t,yield_f3_m(:,1)','LineWidth',2,'Color','blue','LineStyle','--');legend('actual data','macro','macro+MY')
%                   hold off;
%                   grid on
%    subplot(3,2,2);plot(t,yields(:,2)','LineWidth',1.6,'Color','red');title('1 Year Bond Yield');hold on
%                   plot(t,yield_f3(:,2)','LineWidth',2,'Color','green','LineStyle',':');
%                   plot(t,yield_f3_m(:,2)','LineWidth',2,'Color','blue','LineStyle','--');legend('actual data','macro','macro+MY')
%                   hold off;
%                   grid on
%    subplot(3,2,3);plot(t,yields(:,3)','LineWidth',1.6,'Color','red');title('2 Years Bond Yield');hold on
%                   plot(t,yield_f3(:,3)','LineWidth',2,'Color','green','LineStyle',':');
%                   plot(t,yield_f3_m(:,3)','LineWidth',2,'Color','blue','LineStyle','--');legend('actual data','macro','macro+MY')
%                   hold off;
%                   grid on
%    subplot(3,2,4);plot(t,yields(:,4)','LineWidth',1.6,'Color','red');title('3 Years Bond Yield');hold on
%                   plot(t,yield_f3(:,4)','LineWidth',2,'Color','green','LineStyle',':');
%                   plot(t,yield_f3_m(:,4)','LineWidth',2,'Color','blue','LineStyle','--');legend('actual data','macro','macro+MY')
%                   hold off;
%                   grid on
%    subplot(3,2,5);plot(t,yields(:,5)','LineWidth',1.6,'Color','red');title('4 Years Bond Yield');hold on
%                   plot(t,yield_f3(:,5)','LineWidth',2,'Color','green','LineStyle',':');
%                   plot(t,yield_f3_m(:,5)','LineWidth',2,'Color','blue','LineStyle','--');legend('actual data','macro','macro+MY')
%                   hold off;
%                   grid on
%    subplot(3,2,6);plot(t,yields(:,6)','LineWidth',1.6,'Color','red');title('5 Years Bond Yield');hold on
%                   plot(t,yield_f3(:,6)','LineWidth',2,'Color','green','LineStyle',':');
%                   plot(t,yield_f3_m(:,6)','LineWidth',2,'Color','blue','LineStyle','--');legend('actual data','macro','macro+MY')
%                   hold off;
%                   grid on
%   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   %simulated the 5-year yield has a unit root and a transitory componnet
%   %and randomly simulate a bunch of 40-year paths of the data. To check
%   %what fraction of those simulations is there a statistically significant
%   %correlation between the simulated path and the fixed 40-year paths of
%   %the data
%   sim = 200;         %simulation time
%   t= size(yy,2);
%   for i = 1:sim
%      esp = randn(t,1);
%      y_sim = zeros(t+1,1);
%      y_sim(1:1) = yield(20,6); % adopt 1968Q4 5-year yield value as initial value
%      for j = 2:t
%      y_sim(j,1) = y_sim(j-1,1)+esp(j-1,1);
%      end
%      y5_ur = y_sim(2:end,1);
% %      [corre(i,1) p_value(i,1) ] = corr(y5_ur,my_1);
%      se(i,1) = std(bootstrp(1000,@corr,my_1,y5_ur));
%      me(i,1) = mean(bootstrp(1000,@corr,my_1,y5_ur));
%      clear esp y_sim
%   end
%   mean(se)
%   mean(me)
% 
% % %   se_corr = std(bootstrp(1000,@corr,my_1,y5_ur));
% %   mean_corr = mean(bootstrp(1000,@corr,my_1,y5_ur));