% Program for paper "Demographics and the Behavior of Interest Rate" (2010) 
% by Carlo A. Favero, Arie E. Gozlukluy and Haoxi Yang
% In smaple estimation and out of sample forecast
% Haoxi Yang Nov. 25,2014
%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% This code just use the whole sample estimators to simulate yield curve
% for different maturities. Here we just simulate the case with constant
% risk premium.(lamda1=zeros(5,5))
%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clear all; close all;
clc;
addpath('.\data;','.\Library;','.\Results;')

load estimation_demog_trp1_wholesample.mat;  % down load the workplace for whole_sample estimation with my
my=xlsread('MainDataset.xls','Quarterly','Z374:Z701'); %1969Q1-2050Q4
[k t]=size(yy);
ll=length(my);

%% 1 in sample estimation and out of sample forecast with MY
fname = [cd, '\Results\\Estimation\WholeSample\CS3_tays1_ma2',num2str(mac),'_f_trp',num2str(trp),'_rest',num2str(rest)];
load(fname);
theta = mean(thetall(:,:),2);
phi = reshape(theta(1:K^2),K,K); 
del2= theta(end);
% in sample estimation from 1964q1-2013q4
Xs_r = [Xo ; Xu];
y_est_my = zeros(k,t);
my_3= -my(1:t, 1);
my_4= my_3-mean(my_3);
for j=1:t
    y_est_my(:,j) = 400*(AA1 +  BB1*Xs_r(:,j) + del2*ones(6,1)*my_4(j));%+100*del2*(-mean(my_3))*ones(6,1);
end 
y_est_my = y_est_my';
% forcast from 2014q1-2045q4
Xs = zeros(K,ll-t+1);
Xs(1:K-K2,1)=Xo(:,end);
Xs(K2:end,1)=Xu(:,end);
[k1 t1]=size(Xs);
for i=1:k1
    mXs(1,i) = mean(Xstate(i+1,:));
end
mu = (eye(K)-phi)*mXs';
for i=2:ll-t+1
    Xs(:,i)=mu+phi*Xs(:,i-1);
end
my_1= -my(t+1:end, 1);
my_2= my_1-mean(my_3);
ys = zeros(k,ll-t);
for j=1:ll-t
    ys(:,j) = 400*(AA1 +  BB1*Xs(:,j+1) + del2*ones(6,1)*my_2(j));%+100*del2*(-mean(my_1))*ones(6,1);
end 
ys=ys';
yf2045_my = ys;
yield_f1_m = [y_est_my; yf2045_my];
fname = [cd,'\Results\forecast\yield_f1_m'];
save(fname, 'yield_f1_m');

%% 2 in sample estimation and out of sample forecast without MY
load estimation_trp1_wholesample.mat;  % down load the workplace for whole_sample estimation with my
my=xlsread('MainDataset.xls','Quarterly','Z374:Z701'); %1969Q1-2050Q4
[k t]=size(yy);
ll=length(my);
fname = [cd, '\Results\Estimation\WholeSample\CS3_ll_ma2',num2str(mac),'_f_trp',num2str(trp)];
load(fname);
theta = thetall(:,1);
phi = reshape(theta(1:K^2),K,K); 
Xs_r = [Xo ; Xu];
% in sample estimation from 1969q1-2007q4
y_est = zeros(k,t);
for j=1:t
    y_est(:,j) = 400*(AA1 + BB1*Xs_r(:,j));
end 
y_est = y_est';
% out of sample forecast from 2008q1-2045q4
Xs = zeros(K,ll-t+1);
Xs(1:K-K2,1)=Xo(:,1);
Xs(K2:end,1)=Xu(:,1);
[k1 t1]=size(Xs);

for i=1:k1
    mXs(1,i) = mean(Xstate(i+1,:));
end
mu = (eye(K)-phi)*mXs';
for i=2:ll-t+1
    Xs(:,i)=mu+phi*Xs(:,i-1);
end

ys = zeros(k,ll-t);
for j=1:ll-t
    ys(:,j) = 400*(AA1 + BB1*Xs(:,j+1));
end 
yf2045=ys';
yield_f1 = [y_est; yf2045];
fname = [cd,'\Results\forecast\yield_f1'];
save(fname, 'yield_f1');

%% 3 plotting comparison
fname = [cd, '\Results\forecast\yield_f1'];  
load(fname);
yield_f1=yield_f1;
fname = [cd, '\Results\forecast\yield_f1_m'];  
load(fname);
yield_f1_m=yield_f1_m;
yields=yield(nRoll+1:end,:);
% %yields = [yield(nRoll+1:end,:); zeros(size(yf2045))];
Time_data = 1964+1/4 : 1/4 : 2045+4/4;    
t=Time_data';
% figure
% plot(t,yield_f1','LineWidth',0.8);legend('3 Month Bond Yield','1 year Bond Yield','2 year Bond Yield','3 year Bond Yield','4 year Bond Yield','5 year Bond Yield');
% hold on
y3mean = mean(yield(:,1))*ones(ll,1);
y5mean = mean(yield(:,6))*ones(ll,1);
% plot(t,y3mean,'LineWidth',2.0,'Color','black','LineStyle','--');
% hold off
figure
subplot(2,1,1);
plot(t,yield_f1_m(:,1)','LineWidth',2.5);hold on
plot(t,yield_f1(:,1)','LineWidth',2.5,'Color','r');hold on
plot(t,y3mean,'LineWidth',3.0,'Color','black','LineStyle','--'); hold on
legend('Unrestricted Model','Restricted Model','3-month Tbill in-smaple mean');
plot(2014,-2:0.25:18,'LineWidth',3.0,'Color','black','LineStyle','--');
hold off; title('Three-Month Treasury Bill')
xlim ([1964 2045]); ylim ([-0.7 17]);
subplot(2,1,2);
plot(t,yield_f1_m(:,6)','LineWidth',2.5);hold on
plot(t,yield_f1(:,6)','LineWidth',2.5,'Color','r');hold on
plot(t,y5mean,'LineWidth',3.0,'Color','black','LineStyle','--'); hold on
legend('Unrestricted Model','Restricted Model','5-year Tbond in-smaple mean');
plot(2014,-2:0.25:18,'LineWidth',3.0,'Color','black','LineStyle','--');
hold off;title('Five-Year Treasury Bond')
xlim ([1964 2045]);ylim ([-0.7 17]);

%% Long Projection of the real rate
load RepRealRate.mat
 
yields   = GSWdata;              % zero-coupon yields with maturity 3m, 1y-5-y
Infl_ann = Infl_ann(4:end); 
date_Infl= date_Infl(4:end); 

% compute expected inflation
% assum annulized Inlfation follows AR(1) process
Infl= zeros(size(GSWdata,1)+4,1);

for ii = 1:size(GSWdata,1)+4
    lhv = Infl_ann(5:52+ii-1); rhv = [ones(size(lhv)) Infl_ann(1:48+ii-1)];
    [bv,sebv,R2v,R2vadj,v,F] = olsgmm(lhv,rhv,1,1); 
    for kk = 1:1
        drift = 0;
        for jj = 1:kk
            drift = drift + bv(1)*bv(2)^(jj-1);
            Infl_f(jj) = bv(2)^jj*lhv(end)+drift;
        end
        Infl(ii,kk) = mean(Infl_f);
    end
end

for jj = 1:size(2013+4/4:1/4:2045+4/4,2)
    Infl(218+jj) = bv(1) + bv(2)*Infl(218+jj-1);
end

Infl_3m = 400*((1+Infl(:,1)./100).^(1/4)-1);
% plot([Infl_3m Infl(:,end)])

% start from 1964Q1
Infl_3m = Infl_3m(5+11:end-4,1);

% figure
% plot(t,yield_f1_m(:,1)-Infl_3m,'LineWidth',2.5);hold on
% plot(t,yield_f1(:,1)-Infl_3m,'LineWidth',2.5,'Color','r');hold on
% plot(t,y3mean-mean(Infl_3m(1:218)),'LineWidth',3.0,'Color','black','LineStyle','--'); hold on
% legend('Unrestricted Model','Restricted Model','3-month Tbill in-smaple mean');
% plot(2014,-4:0.25:18,'LineWidth',3.0,'Color','black','LineStyle','--');
% plot(t,0,'LineWidth',3.0,'Color','black','LineStyle','--');
% hold off; title('Three-Month Treasury Bill')
% xlim ([1964 2045]); ylim ([-3 12]);
